import React from 'react';
import cx from 'classnames';
import AtomLabel from '@s-ui/react-atom-label';
import { suitClass, switchClassNames } from './helpers';
import PropTypes from 'prop-types';
export var SingleSwitchTypeRender = function SingleSwitchTypeRender(_ref) {
  var _cx;

  var disabled = _ref.disabled,
      isFocus = _ref.isFocus,
      isClick = _ref.isClick,
      isToggle = _ref.isToggle,
      label = _ref.label,
      labelOptionalText = _ref.labelOptionalText,
      name = _ref.name,
      onBlur = _ref.onBlur,
      onFocus = _ref.onFocus,
      onClick = _ref.onClick,
      onKeyDown = _ref.onKeyDown,
      onToggle = _ref.onToggle,
      size = _ref.size,
      type = _ref.type,
      value = _ref.value;
  var isActive = value !== undefined ? value : isToggle;
  return React.createElement("div", {
    className: switchClassNames(size, type, 'singleType', isActive, isFocus, isClick, disabled),
    onClick: function onClick() {
      return onToggle();
    }
  }, React.createElement("div", {
    className: suitClass({
      element: 'container'
    }),
    tabIndex: "0",
    onKeyDown: onKeyDown,
    onFocus: onFocus,
    onClick: onClick,
    onBlur: onBlur
  }, React.createElement(AtomLabel, {
    name: name,
    text: label,
    optionalText: labelOptionalText
  }), React.createElement("div", {
    className: suitClass({
      element: 'inputContainer'
    })
  }, React.createElement("div", {
    className: cx(suitClass({
      element: 'circle'
    }), (_cx = {}, _cx[suitClass({
      modifier: 'toggle'
    })] = isActive, _cx))
  }))));
};
SingleSwitchTypeRender.displayName = 'SingleSwitchTypeRender';