import React from 'react';
import cx from 'classnames';
import AtomLabel from '@s-ui/react-atom-label';
import { suitClass, switchClassNames } from './helpers';
import PropTypes from 'prop-types';
export var ToggleSwitchTypeRender = function ToggleSwitchTypeRender(_ref) {
  var _cx;

  var disabled = _ref.disabled,
      isFocus = _ref.isFocus,
      isClick = _ref.isClick,
      isToggle = _ref.isToggle,
      label = _ref.label,
      labelLeft = _ref.labelLeft,
      labelOptionalText = _ref.labelOptionalText,
      labelRight = _ref.labelRight,
      name = _ref.name,
      onBlur = _ref.onBlur,
      onFocus = _ref.onFocus,
      onClick = _ref.onClick,
      onKeyDown = _ref.onKeyDown,
      onToggle = _ref.onToggle,
      size = _ref.size,
      type = _ref.type,
      value = _ref.value;
  var isActive = value !== undefined ? value : isToggle;
  return React.createElement("div", {
    className: switchClassNames(size, type, 'toggleType', isActive, isFocus, isClick, disabled)
  }, React.createElement(AtomLabel, {
    name: name,
    text: label,
    optionalText: labelOptionalText
  }), React.createElement("div", {
    className: cx(suitClass({
      element: 'container'
    })),
    tabIndex: "0",
    onFocus: onFocus,
    onClick: onClick,
    onBlur: onBlur,
    onKeyDown: onKeyDown
  }, React.createElement("span", {
    className: cx(suitClass({
      element: 'text'
    }), suitClass({
      element: 'left'
    })),
    onClick: function onClick() {
      return onToggle(false);
    }
  }, labelLeft), React.createElement("div", {
    className: cx(suitClass({
      element: 'inputContainer'
    })),
    onClick: function onClick() {
      return onToggle();
    }
  }, React.createElement("div", {
    className: cx(suitClass({
      element: 'circle'
    }), (_cx = {}, _cx[suitClass({
      modifier: 'toggle'
    })] = isActive, _cx))
  })), React.createElement("span", {
    className: cx(suitClass({
      element: 'text'
    }), suitClass({
      element: 'right'
    })),
    onClick: function onClick() {
      return onToggle(true);
    }
  }, labelRight)));
};
ToggleSwitchTypeRender.displayName = 'ToggleSwitchTypeRender';